daala: daala_image_plane Struct Reference

daala 0.0-1733-g24f889a-dirty Experimental Daala video codec API reference.

Loading...
Searching...
No Matches
daala_image_plane Struct Reference

Representation of a single component within an image or frame. More...

`#include <codec.h>`

## Data Fields
unsigned char * | data
| Image data is stored as an unsigned octet type whether it's actually 8 bit or a multi-byte depth.
unsigned char | xdec
| The decimation factor in the x and y direction.
unsigned char | ydec
int | xstride
| Distance in memory between two pixels horizontally next to each other.
int | ystride
| Distance in memory between two pixels vertically next to each other.
int | bitdepth
| 8 for 'normal' video precision; data is unsigned bytes centered on 128.

## Detailed Description

Representation of a single component within an image or frame.

## Field Documentation

## ◆ xdec

unsigned char daala_image_plane::xdec

The decimation factor in the x and y direction.

Pixels are reduced by a factor of 2^xdec so 0 is none, 1 is decimated by a factor of 2. ( YUV420 will have xdec of 1 and ydec also of 1. YUV444 will have xdec and ydec set to zero ).

## ◆ xstride

int daala_image_plane::xstride

Distance in memory between two pixels horizontally next to each other.

The value is in bytes regardless of the 'actual' underlying depth (either unsigned bytes for 8 bit video or unsigned 16 bit shorts for high-depth video). The xstride may be larger than the actual data width calculated from the bitdepth; this implies packed rather than planar data.

## ◆ ystride

int daala_image_plane::ystride

Distance in memory between two pixels vertically next to each other.

As with xstride, this value is always in bytes.

## ◆ bitdepth

int daala_image_plane::bitdepth

8 for 'normal' video precision; data is unsigned bytes centered on 128.

Greater-than-8 indicates high-depth video; data is unnormalized host-endian order unsigned signed 16-bit shorts (two octets). For example, 10 bit video would declare a bit depth of 10, use the lower 10 bits of each 16 bit short, and center on 512.

The documentation for this struct was generated from the following file:

- daala/codec.h